#include "asm86.h" 
#include "ti86asm.inc"
#include "ti86math.inc"
#include "ti86ops.inc"

_ioprompt	=$c324
_asap_ind	=$d623
number =_plotSScreen
answer =_plotSScreen+2
streak =_plotSScreen+4
tries =_plotSScreen+6

.org _asm_exec_ram

MAIN_MENU:
	call _runindicoff
	call _flushAllMenus
	sub a
	ld (streak),a
	ld (tries),a
	ld a,1				;Where the user is pointing
	push af				;Save for later
	call FastClear			;Clear Screen
	call _homeup			;Cursor to (0,0)
	ld hl,TITLE			;Loads the text
	set textInverse,(iy+textflags)	;Inverse Text
	res appAutoScroll,(iy+appflags)	;No auto scrolling...
	call _puts			;Display Text
	res textInverse,(iy+textflags)	;This is to disp Kevin Lee regular
	ld bc,519			;(2,7)
	ld (_curRow),bc
	ld hl,TITLE_TWO
	call _puts
MAIN_MENU_LOOP:
	pop af
	push af
	cp 2
	jr c,MAIN_MENU_ONE
	jr z,MAIN_MENU_TWO
	jr MAIN_MENU_THREE
MAIN_MENU_ONE:				;This is Uninverted Instructions
	ld bc,1028			;(4,4)
	ld (_curRow),bc
	res textInverse,(iy+textflags)	;It is always inverted at the beginning, so I uninvert
	ld hl,REG_MENU_ONE		
	call _puts
	call _newline			;(0,5)
	set textInverse,(iy+textflags)	;Invert
	ld hl,INV_MENU_TWO
	call _puts
	ld hl,INV_MENU_THREE
	call _puts
	call _getkey			;Wait for Keypress
	jr GETKEY_ONE
MAIN_MENU_TWO:				;This is Uninverted Play Game
	ld bc,4				;(0,4)
	ld (_curRow),bc
	ld hl,INV_MENU_ONE
	call _puts
	ld bc,1285			;(5,5)
	ld (_curRow),bc
	ld hl,REG_MENU_TWO
	res textInverse,(iy+textflags)	;Uninvert
	call _puts
	call _newline
	ld hl,INV_MENU_THREE
	set textInverse,(iy+textflags)	;invert
	call _puts
	call _getkey			;Wait for Keypress
	jr GETKEY_ONE
MAIN_MENU_THREE:			;This is Uninverted EXIT
	ld bc,4				;(0,4)
	ld (_curRow),bc
	ld hl,INV_MENU_ONE
	call _puts
	ld hl,INV_MENU_TWO
	call _puts
	ld bc,2054			;(8,6)
	ld (_curRow),bc
	ld hl,REG_MENU_THREE
	res textInverse,(iy+textflags)	;Uninvert
	call _puts
	set textInverse,(iy+textflags)	;invert so the jump will work...
	call _getkey			;Wait for Keypress
GETKEY_ONE:
	cp kLeft			;Left Button
	jr z,UP
	cp kUp				;Up Button
	jr z,UP
	cp kDown			;Down Button
	jr z,DOWN
	cp kRight			;Right Button
	jr z,DOWN
	cp kEnter			;Check for the Enter to move on
	jp nz,MAIN_MENU_LOOP
	call _clrScrn			;Clear Screen
	pop af
	cp 2
	jr c,INSTRUCTIONS
	jp z,GAME
	call _homeup
	set appAutoScroll,(iy+appflags)	;If Entered on "EXIT" then ... exit
	res textInverse,(iy+textflags)	;Don't want screwy text...so uninvert
	ret
UP:
	pop af				;af has the 1,2,3 of which menu to go to
	dec a				;Go down by one
	jr z,TOO_LOW
	push af
	jp MAIN_MENU_LOOP
DOWN:
	pop af
	inc a				;Go up by one
	cp 4				;If a is now 4
	jr z,TOO_HIGH
	push af
	jp MAIN_MENU_LOOP
TOO_LOW:
	ld a,3				;If a was 0, load 3 to a
	push af
	jp MAIN_MENU_LOOP
TOO_HIGH:
	ld a,1				;If a was 4, load 1 to a
	push af
	jp MAIN_MENU_LOOP
INSTRUCTIONS:
	call _homeup			;Cursor to (0,0)
	ld hl,INV_MENU_ONE		;Disp "Instructions" at the top
	call _puts
	res textInverse,(iy+textflags)
	ld hl,INSTRUCTIONS_ONE		;The First Set of Instructions
	call _puts
	call _getkey
	call FastClear			;Clear Screen
	call _homeup			;Cursor to (0,0)
	set textInverse,(iy+textflags)
	ld hl,INV_MENU_FOUR		;Disp "Hints" at the top
	call _puts
	res textInverse,(iy+textflags)
	ld hl,INSTRUCTIONS_TWO
	call _puts
	call _getkey
	call FastClear			;Clear Screen
	call _homeup			;Cursor to (0,0)
	set textInverse,(iy+textflags)
	ld hl,INV_MENU_FIVE		;Disp "How to Win" at the top
	call _puts
	res textInverse,(iy+textflags)
	ld hl,INSTRUCTIONS_THREE
	call _puts
	call _getkey
	jp MAIN_MENU	
GAME:
	res appAutoScroll,(iy+appflags)
	set textInverse,(iy+textflags)
	call FastClear
	call _homeup
	ld hl,GAME_TITLE_ONE
	call _puts
	ld bc,6				;(0,6)
	ld (_curRow),bc
	ld hl,GAME_TITLE_TWO
	call _puts
	ld hl,GAME_TITLE_THREE
	call _puts
	res textInverse,(iy+textflags)	;Don't want screwy text...
	sub a				;Clears out  the last answer
	ld (answer),a
	ld d,127
DRAW_DICE_TOP:	
	ld a,d
	ld d,25
	sub d
	ld d,a
	ld e,25				;X Coordinate = d->d+21, Y=e d={102,77,52,27,2}, e=25
	call DICE_HORIZ
	ld a,d
	cp 2
	jr nz,DRAW_DICE_TOP
	ld d,127
DRAW_DICE_BOTTOM:	
	ld a,d
	ld d,25
	sub d
	ld d,a
	ld e,42				;X Coordinate = d->d+21, Y=e d={102,77,52,27,2}, e=42
	call DICE_HORIZ
	ld a,d
	cp 2
	jr nz,DRAW_DICE_BOTTOM
	ld d,148
DRAW_DICE_RIGHT:
	ld a,d
	ld d,25
	sub d
	ld d,a
	ld e,42
	ld b,18
	call DICE_VERTI
	ld a,d
	cp 23
	jr nz,DRAW_DICE_RIGHT
	ld d,127
DRAW_DICE_LEFT:
	ld a,d
	ld d,25
	sub d
	ld d,a
	ld e,42
	ld b,18
	call DICE_VERTI
	ld a,d
	cp 2
	jr nz,DRAW_DICE_LEFT
	ld b,5					;I need to get five random numbers
RANDM_NUMBERS:
	push bc
	ld a,b
	add a,a
	add a,a
	dec a
	ld (_curCol),a
	ld a,1
	ld (_curRow),a
	ld a,b					;actually b times 25
	add a,a
	add a,a
	add a,b
	ld b,a
	add a,a
	add a,a
	add a,b
	push af
RANDM_NUMS:
	call _ZEROOP1
	call 55DAh 	 			;random number (same as the rand in basic)
						;We now have a number like .99384723
	ld a,6		 			;load a with 6
	call _setXXop2   			;6 in Op2
	call _FPMULT	 			;Op1*6
						;We now have a number like 5.2847723
	call _INTGR	 			;floor it
	call _OP2SET1	 			;1 is in op2
	call _FPADD	 			;op1+op2
	call _dispOP1				;Disp op1 (the random number)
	call _convop1				;op1 -> a
	ld (number),a				;load the dice number
	ld b,a
	cp 2
	jr z,EVEN
	cp 4
	jr z,EVEN
	cp 6
	jr Z,EVEN
	dec b					;subtract one
	ld a,(answer)				;ld the answer thus far
	add a,b					;add it to the current answer
	ld (answer),a				;store the new answer
	pop af
	push af
	ld b,13
	sub b
	ld d,a
	ld e,33
	call DRAW_DOT				;Draw the Center Dot
	ld a,(number)
	cp 1
	jr z,RANDOM_NUMBERS_FINISH
EVEN:	
	pop af
	push af		
	ld b,21					;Draw top left and bottom right
	sub b
	ld d,a
	ld e,27
	call DRAW_DOT
	pop af
	push af	
	ld b,5
	sub b
	ld d,a
	ld e,39
	call DRAW_DOT
	ld a,(number)
	cp 4					;If it is less than three go back
	jr c,RANDOM_NUMBERS_FINISH
	pop af
	push af
	ld b,21					;Draw top right and bottom left
	sub b
	ld d,a
	ld e,39
	call DRAW_DOT
	pop af
	push af
	ld b,5
	sub b
	ld d,a
	ld e,27
	call DRAW_DOT
	ld a,(number)
	cp 6
	jr nz,RANDOM_NUMBERS_FINISH		;If it isn't 6
	pop af
	push af
	ld b,21
	sub b
	ld d,a
	ld e,33
	call DRAW_DOT
	pop af
	push af
	ld b,5
	sub b
	ld d,a
	ld e,33
	call DRAW_DOT
RANDOM_NUMBERS_FINISH:	
	pop bc
	pop bc
	djnz RANDM_NUMBERS_TWO
GETKEY_TWO:
	call _getkey
	cp kClear
	jp z,MAIN_MENU
	cp kEnter
	jr nz,GETKEY_TWO
	ld a,(tries)
	inc a
	ld (tries),a
	call input		;input number and store in op1
	ld bc,2
	ld (_curRow),bc
	call _convop1		;input stored to a
	ld b,a
	ld a,(answer)
	cp b
	jr z,CORRECT
	jr INCORRECT
RANDM_NUMBERS_TWO:
	jp RANDM_NUMBERS
CORRECT:
	ld a,(streak)
	inc a
	ld (streak),a
	ld hl,YES
	call _puts
	jr STATS
INCORRECT:
	sub a
	ld (streak),a
	ld hl,NO
	call _puts
	ld h,0
	ld a,(answer)
	ld l,a
	call DISPLAY
	jr STATS
STATS:
	ld bc,6
	ld (_curRow),bc
	ld hl,STREAK_STRING
	call _puts
	ld h,0
	ld a,(streak)
	ld l,a
	call DISPLAY
	call _newline
	ld hl,TRIES_STRING
	call _puts
	ld h,0
	ld a,(tries)
	ld l,a
	call DISPLAY
	call _getkey
	ld a,(tries)
	cp 99
	jr z,LOSE
	ld a,(streak)
	cp 6
	jp nz,GAME
WIN:
	call FastClear
	ld bc,1539
	ld (_curRow),bc
	ld hl,WINNER
	call _puts
	call _getkey
	jp MAIN_MENU
LOSE:
	call FastClear
	ld bc,515
	ld (_curRow),bc
	ld hl,LOSER
	call _puts
	call _getkey
	jp MAIN_MENU

	
;;;-------------------------------;;;
;;;-----------VARIABLES-----------;;;
;;;-------------------------------;;;


TITLE: 	.db "                     "
	.db "   Petals Around     "
	.db "      The Rose       "
	.db "                     "
	.db "                     ",0,0,0,0,0

INV_MENU_ONE:  .db "    Instructions     ",0
INV_MENU_TWO:  .db "     Play Game       ",0
INV_MENU_THREE:  .db "        EXIT         ",0
INV_MENU_FOUR:  .db "        Hints        ",0
INV_MENU_FIVE:  .db "     How to Win      ",0

TITLE_TWO:  .db "Made by Kevin Lee",0
REG_MENU_ONE:  .db "Instructions",0
REG_MENU_TWO:  .db "Play Game",0
REG_MENU_THREE:  .db "EXIT",0
INSTRUCTIONS_ONE:  	.db "The calculator will  "
			.db "roll 5 dice and find "
			.db "the answer.  You have"
			.db "to determine how the "
			.db "calculator gets it.",0,0,0,0,0
INSTRUCTIONS_TWO:	.db "1.The Name of the    "
			.db "Game is Petals Around"
			.db "the Rose. The Name of"
			.db "the Game is important"
			.db "2.The Answer's always"
			.db "0 or an even number.",0,0,0,0,0,0
INSTRUCTIONS_THREE:	.db "You will input your  "
			.db "Answer for each roll,"
			.db "and the calculator   "
			.db "will display the real"
			.db "Answer. Once you get "
			.db "6 Correct Answers in "
			.db "a row, you will win.",0,0,0,0,0,0,0
GAME_TITLE_ONE:		.db " Observe the Dice... ",0
GAME_TITLE_TWO:		.db "Press ENTER to answer",0
GAME_TITLE_THREE:	.db " Press CLEAR to quit ",0
Prompt:			.db "Answer:",0
YES:			.db "CORRECT!!!",0
NO:			.db "No, the answer was ",0
NUMBERS:
			.db "0"
			.db "1"
			.db "2"
			.db "3"
			.db "4"
			.db "5"
			.db "6"
			.db "7"
			.db "8"
			.db "9"
STREAK_STRING:		.db "Current Streak: ",0
TRIES_STRING:		.db "Total Tries: ",0
WINNER:			.db "YOU WIN!!!",0
LOSER:			.db "TRY AGAIN LATER...",0

;----------------------------------;
;--------------CALLS---------------;
;----------------------------------;

FindPixel:
     ld h,63
     ld a,e
     add a,a
     add a,a
     ld l,a
     ld a,d
     rra
     add hl,hl
     rra
     add hl,hl
     rra
     or l
     ld l,a
     ld a,d
     and 7
     ld de,FP_Bits
     add a,e
     ld e,a
     adc a,d
     sub e
     ld d,a
     ld a,(de)
     ret

FP_Bits:     .db $80,$40,$20,$10,$08,$04,$02,$01


DICE_HORIZ:
	push de
	call FindPixel
	sla a
	dec a
	push af
	ld (hl),a
	inc hl
	ld b,%11111111
	ld (hl),b
	inc hl
	ld (hl),b
	inc hl
	pop af
	cpl
	sla a
	sla a
	or (hl)
	ld (hl),a
	pop de
	ret

DICE_VERTI:
	push de
	call FindPixel
	ld de,-16
	ld c,a
DICE_VERTI_LOOP:
	ld a,c
	or (hl)
	ld (hl),a
	add hl,de
	djnz DICE_VERTI_LOOP
	pop de
	ret

DRAW_DOT:
	call FindPixel
	ld b,a
	srl a
	jr c,OVERBOARD
	add a,b
	or (hl)
	ld (hl),a
	ld de,16
	add hl,de
	ld (hl),a
	ret

OVERBOARD:
	ld a,1
	or (hl)
	ld (hl),a
	inc hl
	ld a,%10000000
	or (hl)
	ld (hl),a
	ld de,16
	add hl,de
	ld (hl),a
	dec hl
	ld a,1
	or (hl)
	ld (hl),a
	ret

B_TIMES_FIVE:
	ld a,b			;actually b times 25
	add a,a
	add a,a
	add a,b
	ld b,a
	add a,a
	add a,a
	add a,b
	ret
input:		
	ld de,_ioprompt
	ld hl,Prompt		;string to prompt with	
	call _MOV10B
	ld a,$0d
	ld (_asap_ind),a
	call _homeup
	call _clrScrn		;clear screen & text memory
	call _exec_pg3
	ret

FastClear:
    ld hl,$fc00      ;load video into hl
	ld de,1          ;load 1 into de
	ld c,64          ;number of vertical lines
    ld a,%00000000   ;load the blank line into a					  
    ld (hl),a        ;draw the clear line
clear:
	ld b,16          ;number of horizontal lines
    ld a,%00000000   ;load next blank line
clearing:
    add hl,de        ;adds de to hl
    ld (hl),a        ;load a into hl
    djnz clearing    ;decrement and jump to clearing if not zero
	dec c            ;decrease c
	ld a,c           ;load c into a
	jr nz,clear      ;jump relevant to clear if not zero
	ret              ;exit the routine

DISPLAY:
	ld de, NUMBERS
	ld a,l
	cp 10
	jr c,_disp	            ; HL = HL  10, A = remainder
    	XOR    A         ; Clear upper eight bits of AHL
    	LD     B, 16      ; Sixteen bits in dividend
_loop: 
	ADD    HL, HL     ; Do a SLA HL
    	RLA              ; This moves the upper bits of the dividend into A
    	JR     C, _overflow
    	CP     10         ; Check if we can subtract the divisor
    	JR     C, _skip   ; Carry means D > A
_overflow:
    	SUB    10         ; Do subtraction for real this time
    	INC    L         ; Set bit 0 of quotient
_skip:
    	DJNZ   _loop
	ld b,a
	ld de,NUMBERS
     	add hl,de
	ld a,(hl)
	call _putc
	ld a,b
_disp:
	add a,e
     	ld e,a
     	adc a,d
     	sub e
     	ld d,a
     	ld a,(de)
	call _putc
	ret


.end
END
